<?php
//// Wepay Production version 2.0
//// wepay_checkout.php mod file
//// written by Alan Pinnt www.alanpinnt.com
//// 2012 ZENCART ONLY
class wepay_checkout
{
  var $code, $title, $description, $enabled;
  // class constructor
  function wepay_checkout()
  {
    global $order;
    $this->signature = 'wepay_checkout|wepay_checkout|2.0|2.2';
    $this->api_version = '0.0.9';
    $this->code = 'wepay_checkout';
    $this->title = MODULE_PAYMENT_WEPAY_CHECKOUT_TEXT_TITLE;
    $this->public_title = MODULE_PAYMENT_WEPAY_CHECKOUT_TEXT_PUBLIC_TITLE;
    $this->description = MODULE_PAYMENT_WEPAY_CHECKOUT_TEXT_DESCRIPTION;
    $this->sort_order = MODULE_PAYMENT_WEPAY_CHECKOUT_SORT_ORDER;
    $this->enabled = ((MODULE_PAYMENT_WEPAY_CHECKOUT_STATUS == 'True') ? true : false);
    if ((int)MODULE_PAYMENT_WEPAY_CHECKOUT_ORDER_STATUS_ID > 0) {
      $this->order_status = MODULE_PAYMENT_WEPAY_CHECKOUT_ORDER_STATUS_ID;
    }
    if (is_object($order)) $this->update_status();
  }
  // class methods
  function update_status()
  {
    global $order;
    if (($this->enabled == true) && ((int)MODULE_PAYMENT_WEPAY_CHECKOUT_ZONE > 0)) {
      $check_flag = false;
      $check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_WEPAY_CHECKOUT_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
      while ($check = zen_db_fetch_array($check_query)) {
        if ($check['zone_id'] < 1) {
          $check_flag = true;
          break;
        }
        elseif ($check['zone_id'] == $order->delivery['zone_id']) {
          $check_flag = true;
          break;
        }
      }
      if ($check_flag == false) {
        $this->enabled = false;
      }
    }
  }

  function javascript_validation()
  {
    return false;
  }

  function selection()
  {
    return array('id' => $this->code , 'module' => $this->public_title);
  }

  function pre_confirmation_check()
  {
    global $insert_id, $customer_id, $order, $currency, $order_totals, $order_id, $checkout,$db;
    $orderamount = number_format($order->info['total'], 2);
    $orderamount = preg_replace('/[\$,]/', '', $orderamount);
    require DIR_FS_CATALOG . 'ext/modules/payment/wepay/wepay.php';
    $client_id = MODULE_PAYMENT_WEPAY_CHECKOUT_CLIENT_ID;
    $client_secret = MODULE_PAYMENT_WEPAY_CHECKOUT_CLIENT_SECRET;
    $access_token = MODULE_PAYMENT_WEPAY_CHECKOUT_ACCESS_TOKEN;
    $account_id = MODULE_PAYMENT_WEPAY_CHECKOUT_ACCOUNT_ID;
    if (MODULE_PAYMENT_WEPAY_CHECKOUT_PRODUCTION == 'Staging') {
      $whattouse = useStaging;
    }
    elseif (MODULE_PAYMENT_WEPAY_CHECKOUT_PRODUCTION == 'Production') {
      $whattouse = useProduction;
    }
    if (MODULE_PAYMENT_WEPAY_CHECKOUT_CHARGETAX == 'Yes') {
      $chargetax = '1';
    }
    else {
      $chargetax = '0';
    }
    
    $state_abbr = $db->Execute("select zone_code from " . TABLE_ZONES . " where zone_name = '" . $order->billing['state'] . "'");
    $arr = array('name' => $order->billing['firstname'].' '.$order->billing['lastname'], 'phone_number' => $order->customer['telephone'], 'email' => $order->customer['email_address'],'address' => $order->billing['street_address'],'state' => $state_abbr->fields['zone_code'],'city' => $order->billing['city'],'zip' => $order->billing['postcode']);

    Wepay::$whattouse($client_id, $client_secret);
    $wepay = new WePay($access_token);
    try {
      $checkout = $wepay->request('/checkout/create', array('account_id' => $account_id ,       // ID of the account that you want the money to go to
                                  'amount' => $orderamount ,       // dollar amount you want to charge the user
                                  'short_description' => "Order " . (int)$_SESSION['customer_id'] . '-' . time(),       // a short description of what the payment is for
                                  'reference_id' => (int)$_SESSION['customer_id'] . '-' . time(),       // A reference id for your application to use.
                                  'type' => "GOODS" ,       // the type of the payment - choose from GOODS SERVICE DONATION or PERSONAL
                                  'mode' => "regular" ,       // put iframe here if you want the checkout to be in an iframe, regular if you want the user to be sent to WePay
                                  'charge_tax' => $chargetax ,       //charge tax or not, boolean value. Tax values are set in your wepay account
                                  'prefill_info' => $arr,
                                  'fee_payer' => MODULE_PAYMENT_WEPAY_CHECKOUT_FEEPAYER ,       // Here you put who is paying the fees you or your client. Payee = client, Payer = account holder
                                  'redirect_uri' => zen_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL', true) ,       // The page where you want clients to go after the transaction is completed.
                                  'callback_uri' => HTTP_SERVER.DIR_WS_CATALOG."ext/modules/payment/wepay/wepayipn.php"))      // Location of the file that handles IPN requests
                                  ;
    }
    catch (WePayException $e) { // if the API call returns an error, get the error message for display later
      $error = $e->getMessage();
    }
    header("Location: $checkout->checkout_uri");
  }

  function confirmation()
  {
    return false;
  }

  function process_button()
  {
    return false;
  }

  function before_process()
  {
    return false;
  }

  function after_process()
  {
    global $insert_id, $cartID;
    $sql_data_array = array('orders_id' => $insert_id , 'orders_status_id' => MODULE_PAYMENT_WEPAY_CHECKOUT_ORDER_STATUS_ID , 'date_added' => 'now()' , 'customer_notified' => '0' , 'comments' => (int)$_SESSION['customer_id'] . '-' . time());
    zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
  }

  function get_error()
  {
    return false;
  }

  function check()
  {
    global $db;
    if (! isset($this->_check)) {
      $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_WEPAY_CHECKOUT_STATUS'");
      $this->_check = $check_query->RecordCount();
    }
    return $this->_check;
  }

  function install()
  {
    global $db;
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Wepay Module', 'MODULE_PAYMENT_WEPAY_CHECKOUT_STATUS', 'True', 'Enable the Wepay Plugin', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Production or Staging', 'MODULE_PAYMENT_WEPAY_CHECKOUT_PRODUCTION', 'Staging', 'Set to Staging if testing, Production for running live transactions', '6', '1', 'zen_cfg_select_option(array(\'Production\', \'Staging\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Account ID', 'MODULE_PAYMENT_WEPAY_CHECKOUT_ACCOUNT_ID', '0', 'Your Account ID from Wepay', '6', '2', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Client ID', 'MODULE_PAYMENT_WEPAY_CHECKOUT_CLIENT_ID', '0', 'Your Client ID from Wepay API', '6', '3', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Client Secret', 'MODULE_PAYMENT_WEPAY_CHECKOUT_CLIENT_SECRET', '0', 'Your Client Secret from Wepay API', '6', '4', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Access Token', 'MODULE_PAYMENT_WEPAY_CHECKOUT_ACCESS_TOKEN', '0', 'Your Access Token from Wepay API', '6', '5', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Fee Payer', 'MODULE_PAYMENT_WEPAY_CHECKOUT_FEEPAYER', 'Payee', '', '6', '6', 'zen_cfg_select_option(array(\'Payee\', \'Payer\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Charge Tax', 'MODULE_PAYMENT_WEPAY_CHECKOUT_CHARGETAX', 'No', 'Charge tax or not.', '6', '5', 'zen_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_WEPAY_CHECKOUT_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '8', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_WEPAY_CHECKOUT_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '9', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_WEPAY_CHECKOUT_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '10', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
  }

  function remove()
  {
    global $db;
    $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
  }

  function keys()
  {
    return array('MODULE_PAYMENT_WEPAY_CHECKOUT_STATUS' , 'MODULE_PAYMENT_WEPAY_CHECKOUT_PRODUCTION' , 'MODULE_PAYMENT_WEPAY_CHECKOUT_ACCOUNT_ID' , 'MODULE_PAYMENT_WEPAY_CHECKOUT_CLIENT_ID' , 'MODULE_PAYMENT_WEPAY_CHECKOUT_CLIENT_SECRET' , 'MODULE_PAYMENT_WEPAY_CHECKOUT_ACCESS_TOKEN' , 'MODULE_PAYMENT_WEPAY_CHECKOUT_FEEPAYER' , 'MODULE_PAYMENT_WEPAY_CHECKOUT_ZONE' , 'MODULE_PAYMENT_WEPAY_CHECKOUT_SORT_ORDER' , 'MODULE_PAYMENT_WEPAY_CHECKOUT_ORDER_STATUS_ID' , 'MODULE_PAYMENT_WEPAY_CHECKOUT_CHARGETAX');
  }
  // format prices without currency formatting
  function format_raw($number, $currency_code = '', $currency_value = '')
  {
    global $currencies, $currency;
    if (empty($currency_code) || ! $this->is_set($currency_code)) {
      $currency_code = $currency;
    }
    if (empty($currency_value) || ! is_numeric($currency_value)) {
      $currency_value = $currencies->currencies[$currency_code]['value'];
    }
    return number_format(zen_round($number * $currency_value, $currencies->currencies[$currency_code]['decimal_places']), $currencies->currencies[$currency_code]['decimal_places'], '.', '');
  }
}



